(function($, jef, window){
		
	window.cambiarLateral = function (id, newClass) {
		$('#' + id).addClass(newClass);
	};

	window.clearText = jef.noop;
		
	//
	// jQuery functions
	//
			
	// Select
	
	$.fn.addSelectOption = function(key, value, selected){
		selected = !!selected;
		return $(this).each(function(i, select){
			var options = select.options, option;
			if (options != null)
		    {
				option = new Option(value, key, false, false);
            	options[options.length] = option;
            	option.selected = selected;
		    }
		});
	};
		
	$.fn.addSelectOptions = function(data, selectedKey) {
        var isArray = jef.isArray(data);
		return this.each(function(i, select) {
			var options = select.options, option;
			if (options != null)
		    {
				$.each(data, function(key, value) {
	            	if(isArray){
	            		key = value.key;
	            		value = value.value;
	            	}	
	            	option = new Option(value, key, false, false);
	            	options[options.length] = option;
	            	option.selected = selectedKey == key;            	 
	            });
		    }
        });
    };
    
    $.fn.clearSelectOptions = function(headerKey, headerValue){
    	// Fix header value
    	if(headerKey != null && headerValue == null){
    		headerValue= this.find('option[value="' + headerKey + '"]').html();
    	}
    	// Clear select
    	this.empty();
    	// And header
    	if(headerValue){
    		var headerOption = {};
    		headerOption[headerKey] = headerValue;
    		this.addSelectOptions(headerOption, headerKey);
    	}   
    	return this;
    };
    
    $.fn.selectAllOptions = function(exceptKey){
    	return this.each(function(j, e){
    	    for (var i = 0, l = e.length, option; i<l; i++) {
    	        option = e.options[i];
    	        option.selected = option.value !== exceptKey;
    	    }
    	});
    };
    
    $.fn.selectOptions = function(keys){
    	var contains = jef.array.contains, keys = keys || [];
    	return this.each(function(j, e){
    	    for (var i = 0, l = e.length, option; i<l; i++) {
    	        option = e.options[i];
    	        option.selected = contains(keys, option.value);
    	    }
    	});
    };
    
    $.fn.getSelectedKeys = function(){
    	var e = this.get(0);
    	if(!e || !e.options)
    		return null;
	    var keys = [], option;
		for (var i = 0, l = e.length, option; i<l; i++) {
	        option = e.options[i];
			if (option.selected === true) {
				keys.push(option.value);
	        }    
	    }
    	return keys;
    };
        
    $.fn.ajaxSelectOptions = function(ajaxOptions, headerKey, headerValue) {
        // Clear select
    	var ws = this.clearSelectOptions(headerKey, headerValue);    			
    	// Ajax call, then add options
    	$.ajax($.extend({
			dataType: 'json',
			context: this,
			success: function(data, status, xhr){
				ws.addSelectOptions(data);
			}
		}, ajaxOptions));
    	// Return current wrapped set
    	return this;
    };
    
    
    // Dialogs
    
    $.dialog = function(uiOptions, dialogOptions){
    	// Ui options
    	uiOptions = $.extend({
    		id: 'dialog-alerta',
    		title: 'Alerta',
    		css: {},
    		className: 'dialog',
    		bgiframe: true,
    		messages: []
    	}, uiOptions || {});
    	// Dialog options
    	dialogOptions = $.extend({
    		autoOpen: false,
    		resizable: false,
    		height: 170,
    		width: 400,
    		modal: true,
    		buttons: {
    			'OK': function() {
					$( this ).dialog( "close" );
				}
    		}
    	}, dialogOptions || {});
    	// Get or create ui
    	var dialog = $('#' + uiOptions.id);
    	if(dialog.size() === 0){
    		dialog = $('<div id="' + uiOptions.id + '" >').hide().appendTo(document.body);
    	} else {
    		dialog.dialog('destroy');
    	}
    	// Set ui 
    	dialog.attr('title', uiOptions.title);
    	if(uiOptions.className) { 
    		dialog.addClass(uiOptions.className);
    	}
    	dialog.css(uiOptions.css);    	
    	dialog.empty();
    	for(var i in uiOptions.messages){
    		dialog.append($('<p>').html(uiOptions.messages[i]));
    	}
    	// Make dialog and return it
    	return dialog.dialog(dialogOptions);
    };
    
    var deleteDialog = function(dialogOptions, deleteOptions){

    	var dialogId = this.attr('id');
		var opt = $.extend({
			// this: dialog
			form: function(){
				return $(this).find('form');
			},
			// this: opt
			deleteAnchors: function(){
				return $('a.delete');
			},
			// this: delete anchor
			deleteTableId: function(){
				return $(this).parents('td').find('.inputIdDelete').val();
			},
			// this: dialog
			deleteFormInput: function(){
				return $(this).find('form #idDeleteForm');
			},
			// this: delete anchor
			beforeOpen: function(dialog){
			},
			highlightRow: true,
			highlightColor: '#BFBFBF'
		}, deleteOptions || {});
		
		this.dialog($.extend({
			autoOpen: false,
			resizable: false,
			bgiframe: true,
			height: 145,
			//minHeight: 0,
			modal: true,
			buttons: {
				'Eliminar': function() {
					opt.form.call(this).submit();
				},
				'Cancelar': function() {
					$( this ).dialog( "close" );
				}
			}
		},dialogOptions || {}));


		var row;
		if(opt.highlightRow === true){
			this.dialog({
				beforeClose: function(event, ui) { 
					// Back to original color
					if(opt.highlightRow === true){
						row.css('background-color', row.data('backgroundColor'));
					}
				}
			});
		}
		
		opt.deleteAnchors().click(function(event){
			var dialog = $( "#" + dialogId );
			opt.beforeOpen.call(this, dialog);
			dialog.dialog('open');
			var id = opt.deleteTableId.call(this);
			opt.deleteFormInput.call(dialog).val(id);
			// Highlight Row
			if(opt.highlightRow === true){
				// Save row
				row = $(this).parents('tr');
				// Set color
				row.css('background-color', opt.highlightColor);
			}			
			return false;
		}).each(function(i, e){
			var row = $(e).parents('tr');
			row.data('backgroundColor', row.css('background-color'));
		});

		return this;
	};
    
    
    $.fn.deleteDialog = function(dialogOptions, deleteOptions){
    	deleteDialog.call(this, dialogOptions, deleteOptions);
    };
    
    $.fn.deleteConfigureCampoDialog = function(dialogOptions, deleteOptions){
    	deleteDialog.call(this, dialogOptions, jef.extend({
			beforeOpen: function(dialog){
				var h = $(this).parents('td').find('.habilitadoDelete').val() === 'true';
				if(h){
					dialog.dialog('option', 'height', 180);
					$('#dialog-confirm p.h').show();
					$('#dialog-confirm p.nh').hide();
				} else {
					dialog.dialog('option', 'height', 145);
					$('#dialog-confirm p.h').hide();
					$('#dialog-confirm p.nh').show();
				}
			}}, deleteOptions || {}));
	 };
	
	 // Input
	 
	 $.fn.clearInputFile = function(attrs){
		attrs = $.extend(['id', 'name', 'class', 'style'], attrs || []);
		this.filter('input:file').each(function(i, e){
			 var file = $(e);
			 // Build new input file
			 var newFile = '<input type="file"', attrName, attrValue;
			 for(var j=0, l=attrs.length; j<l; j++){
				 attrName = attrs[j];
				 attrValue = file.attr(attrName);
				 if(attrValue != null && attrValue !== ''){
					 newFile += ' ' + attrName + '="' + attrValue + '"';
				 }
			 }
			 newFile += '/>';
			 // Insert new file
			 var refElement = file.next();
			 if(refElement.size() > 0){
				 file.remove();
				 $(newFile).insertBefore(refElement);
			 } else {
				 refElement = file.parent();
				 file.remove();
				 $(newFile).appendTo(refElement);
			 }
		});
		return this;
	};
	
	// Filter
	
	$.fn.named = function(name, parseFirstChar){
		var fct;
		if(parseFirstChar === true){
			switch(name.charAt(0)){
			case '^' : 
				name = name.substr(1);
				fct = function(i){
					return this.name && this.name.indexOf(name) === 0;
				}; 
				break;
			case '!' : 
				name = name.substr(1);
				fct = function(i){
					return this.name != name;
				}; 
				break;
			case '$' : 
				name = name.substr(1);
				fct = function(i){	
					if(!this.name)
						return;
					var diff = this.name.length - name.length;
					return diff >= 0 && this.name.lastIndexOf(name) === diff;
				}; 
				break;
			case '*' : 
				name = name.substr(1);
				fct = function(i){
					return this.name.indexOf(name) != -1;
				}; 
				break;
			default:
				fct = function(i){
					return this.name === name;
				};
			}
		} else {
			fct = function(i){
				return this.name === name;
			};
		}
		return this.filter(fct);
	};
			
	//
	// Window method
	//
	
	window.fillOptionTransferSelect = function(leftSlt, rightSlt, data){
		var leftData = {}, rightData = {}, e;
		for(var i=0, l=data.length; i<l; i++){
			e = data[i];
			if(e.value == false){
				leftData[e.key] = e.label;
			} else {
				rightData[e.key] = e.label;
			}
		}
		leftSlt.clearSelectOptions().addSelectOptions(leftData);
		rightSlt.clearSelectOptions().addSelectOptions(rightData);
	};
	
	window.animateFileInput = function(containerSelector, fileNameSelector, fileSelectedSelector, lastClass){
		
		$(containerSelector + ' div.eliminar > a').live('click', function(event){
			var a = $(this);
			var parent = a.parent('div');
			var next = parent.next();
			var row = a.parents('tr');
			var isNew = !row.hasClass('file');
			// Remove rows if new
			if(a.data('_click') !== true && row.children('th[rowspan=2]').size() == 0){
				row.prev().remove();
				row.next().remove();
				row.remove();
				return false;
			}
			if(a.data('_click') == true){
				parent.find('input').val('false');
				next.find('a').show();
				next.find('span').hide();
				row.find('th').attr('rowspan', 2);
				row.next().show().next().show();
				if(lastClass) row.children().removeClass(lastClass);
				a.css('background-position', '0px 0px');
				a.data('_click', false);
			} else {				
				parent.find('input').val('true');
				next.find('a').hide();
				next.find('span').show();
				row.find('th').attr('rowspan', 1);
				row.next().hide().next().hide();
				if(lastClass) row.children().addClass(lastClass);
				a.css('background-position', '0px -17px');
				a.data('_click', true);
			}
			return false;
		});
		
		$(containerSelector + ' div.eliminar input['+ fileSelectedSelector +']').each(function(i, e){
		    var we = $(e);
		    if(we.val() == 'true'){
		        we.parents('div.eliminar').find('a').click();
		    }
		});
		
		$(containerSelector + ' div.undo > a').live('click', function(event){
		    var we = $(this);	
		    we.parents('td').find('input:file').clearInputFile();
		    we.hide();
		    return false;
		}).hide();
		
		$(containerSelector + ' input:file['+ fileNameSelector +']').live('change', function(event){
		    $(this).parents('td').find('div.undo > a').show();
		});
		
	};
	
	$.fn.animateFileInput = function(fileNameSelector, fileSelectedSelector){
		fileNameSelector = fileNameSelector || 'name$=".formFile"';
		fileSelectedSelector = fileSelectedSelector || 'name$=".eliminar"';
		return this.each(function(i, e){
			var tbodyId = $(e).attr('id');
			animateFileInput('#' + tbodyId, fileNameSelector, fileSelectedSelector);			
		});
	};
	
	$.fn.animateMultipleFileInput = function(tplSelector, fileNameSelector, fileSelectedSelector, lastClass){
		fileNameSelector = fileNameSelector || 'name$="].formFile"';
		fileSelectedSelector = fileSelectedSelector || 'name$="].eliminar"';
		lastClass = lastClass || 'separador';
		return this.each(function(i, e){
			// Add Button
			var tbodyId = $(e).attr('id');
			var count = $(e).children('tr').size() / 3;
			$(e).next().find('a.addFile').click(function(event){				
				var tpl = jef.tpl($(tplSelector).html(), [count++]);
				$('#' + tbodyId).append($(tpl));
				return false;
			});
			// Bind event on rows
			animateFileInput('#' + tbodyId, fileNameSelector, fileSelectedSelector, lastClass);
		});
	};
		
}(jQuery, jef, window));